diff --git a/src/polkitagent/polkitagenthelperprivate.c b/src/polkitagent/polkitagenthelperprivate.c
index 4417e70..e04c084 100644
--- a/src/polkitagent/polkitagenthelperprivate.c
+++ b/src/polkitagent/polkitagenthelperprivate.c
@@ -103,7 +103,7 @@ flush_and_wait ()
 {
   fflush (stdout);
   fflush (stderr);
-  fdatasync (fileno(stdout));
-  fdatasync (fileno(stderr));
+  fsync (fileno(stdout));
+  fsync (fileno(stderr));
   usleep (100 * 1000);
 }
diff --git a/src/polkitbackend/polkitbackendinteractiveauthority.c b/src/polkitbackend/polkitbackendinteractiveauthority.c
index 3bd2f0b..ca4a550 100644
--- a/src/polkitbackend/polkitbackendinteractiveauthority.c
+++ b/src/polkitbackend/polkitbackendinteractiveauthority.c
@@ -2113,11 +2113,7 @@ get_users_in_net_group (PolkitIdentity                    *group,
   ret = NULL;
   name = polkit_unix_netgroup_get_name (POLKIT_UNIX_NETGROUP (group));
 
-  if (setnetgrent (name) == 0)
-    {
-      g_warning ("Error looking up net group with name %s: %s", name, g_strerror (errno));
-      goto out;
-    }
+  setnetgrent (name);
 
   for (;;)
     {
diff --git a/test/mocklibc/Makefile.am b/test/mocklibc/Makefile.am
index 3508ecd..6d4de16 100644
--- a/test/mocklibc/Makefile.am
+++ b/test/mocklibc/Makefile.am
@@ -1,3 +1,3 @@
 
-SUBDIRS = src bin
+SUBDIRS = bin
 EXTRA_DIST = example
diff --git a/test/mocklibc/src/grp.c b/test/mocklibc/src/grp.c
index c671e1f..55db9bf 100644
--- a/test/mocklibc/src/grp.c
+++ b/test/mocklibc/src/grp.c
@@ -27,15 +27,16 @@
 
 static FILE *global_stream = NULL;
 
-void setgrent(void) {
+int setgrent(void) {
   if (global_stream)
     endgrent();
 
   const char *path = getenv(GROUP_CONFIG_KEY);
   if (!path)
-    return;
+    return 0;
 
   global_stream = fopen(path, "r");
+  return 1;
 }
 
 struct group *getgrent(void) {
diff --git a/test/mocklibc/src/netdb.c b/test/mocklibc/src/netdb.c
index 9442403..5dc7455 100644
--- a/test/mocklibc/src/netdb.c
+++ b/test/mocklibc/src/netdb.c
@@ -36,7 +36,7 @@ static struct netgroup_iter global_iter;
 
 // REMEMBER: 1 means success, 0 means failure for netgroup methods
 
-int setnetgrent(const char *netgroup) {
+void setnetgrent(const char *netgroup) {
   if (!global_netgroup_head)
     global_netgroup_head = netgroup_parse_all();
 
@@ -44,11 +44,10 @@ int setnetgrent(const char *netgroup) {
   if (!group) {
      netgroup_free_all(global_netgroup_head);
     global_netgroup_head = NULL;
-    return 0;
+    return;
   }
 
   netgroup_iter_init(&global_iter, group);
-  return 1;
 }
 
 void endnetgrent(void) {
